#include <math.h>
#include "SSM_user.h" /* needed by the program which calls SSM */

int main (void)
{
    int n, N, j, k, l, L1, LN, U1, UN, status, *Ai, *Ap ;
    FLOAT radius, rand_max, *x, *b, *Ax ;
    SSMParm Parm ;
    ssm_stat Stat ;
    N = 32 ;
    n = N*N ;
    Ap = malloc ((n+1)*sizeof (int)) ;
    Ai = malloc (5*n*sizeof (int)) ;
    Ax = malloc (5*n*sizeof (FLOAT)) ;
    x  = malloc (n*sizeof (FLOAT)) ;
    b  = malloc (n*sizeof (FLOAT)) ;
    rand_max = (FLOAT) RAND_MAX ;
    k = 0 ;
    Ap [0] = 0 ;
    for (j = 0; j < n; j++)
    {
        b [j] = ((FLOAT) rand ()) / rand_max ;
        L1 = j + 1 ;
        LN = j + N ;
        U1 = j - 1 ;
        UN = j - N ;
        if ( UN >= 0 )
        {
            Ax [k] = (FLOAT) -1 ;
            Ai [k] = UN ;
            k++ ;
        }
        if ( U1 >= 0 )
        {
            l = N*(j/N) ;
            if ( l != j )
            {
                Ax [k] =(FLOAT)  -1 ;
                Ai [k] = U1 ;
                k++ ;
            }
        }
        Ax [k] = (FLOAT) -1 ;
        Ai [k] = j ;
        k++ ;
        if ( L1 < n )
        {
            l = N*((j+1)/N) ;
            if ( l != j+1 )
            {
                Ax [k] = (FLOAT) -1 ;
                Ai [k] = L1 ;
                k++ ;
            }
        }
        if ( LN < n )
        {
            Ax [k] = (FLOAT) -1 ;
            Ai [k] = LN ;
            k++ ;
        }
        Ap [j+1] = k ;
    }
    radius = (FLOAT) 100 ;

    /* make any changes to default parameter settings here */
    SSMdefault (&Parm) ;
    Parm.Lanczos_dim1 = 15 ;
    Parm.Lanczos_dim2 = 100 ;
    Parm.Lanczos_L1 = 15 ;
    Parm.Lanczos_L2 = 30 ;
    Parm.PrintLevel = 3 ;

    /* call SSM */
    status = SSM (x, &Stat, n, Ax, Ai, Ap, b, radius, 1.e-6, NULL, &Parm) ;

    free (Ax) ;
    free (Ai) ;
    free (Ap) ;
    free (x) ;
    free (b) ;
}
