#include <math.h>
#include "SSM_user.h" /* needed by the program which calls SSM */

int main (void)
{
    int n, i, j, k, l, status, *Ai, *Ap ;
    double radius, rand_max, normb, bj, uj, yj, normu, t, c,
           *x, *b, *d, *u, *y, *Ax ;
    SSMParm Parm ;
    ssm_stat Stat ;
    n = 1000 ;
    Ap = malloc ((n+1)*sizeof (int)) ;
    Ai = malloc (n*n*sizeof (int)) ;
    Ax = malloc (n*n*sizeof (double)) ;
    x  = malloc (n*sizeof (double)) ;
    b  = malloc (n*sizeof (double)) ;
    d  = malloc (n*sizeof (double)) ;
    u  = malloc (n*sizeof (double)) ;
    y  = malloc (n*sizeof (double)) ;
    rand_max = (double) RAND_MAX ;
    normb = (double) 0 ;
    normu = (double) 0 ;
    for (j = 0; j < n; j++)
    {
        bj = ((double) rand ()) / rand_max - (double) .5 ;
        b [j] = bj ;
        normb += bj*bj ;
        d [j] = ((double) rand ()) / rand_max - (double) .5 ;
        uj = ((double) rand ()) / rand_max - (double) .5 ;
        u [j] = uj ;
        normu += uj*uj ;
    }
    t = sqrt(2)/normu ;
    c = (double) 0 ;
    for (j = 0; j < n; j++)
    {
        uj *= t ;
        u [j] = uj ;
        yj = y [j] = d [j]*uj ;
        c += yj*uj ;
        b [j] /= normb ;
    }
    /* store the dense matrix (not very efficient) */
    k = 0 ;
    Ap [0] = 0 ;
    for (j = 0; j < n; j++)
    {
        /* A = diag(d) - y*u' - u*y' + (u*c)*u' ;*/
        l = k ;
        for (i = 0; i < n; i++)
        {
            Ax [k] = (c*u [j] - y [j])*u [i]  - y [i]*u [j] ;
            Ai [k] = i ;
            k++ ;
        }
        Ax [l+j] += d [j] ;
        Ap [j+1] = k ;
    }
    free (d) ;
    free (u) ;
    free (y) ;

    radius = (double) 100 ;

    /* make any changes to default parameter settings here */
    SSMdefault (&Parm) ;
    Parm.Lanczos_dim1 = 15 ;
    Parm.Lanczos_dim2 = 100 ;
    Parm.Lanczos_L1 = 15 ;
    Parm.Lanczos_L2 = 30 ;
    Parm.PrintLevel = 3 ;

    /* call SSM */
    status = SSM (x, &Stat, n, Ax, Ai, Ap, b, radius, 1.e-6, NULL, &Parm) ;

    free (Ax) ;
    free (Ai) ;
    free (Ap) ;
    free (x) ;
    free (b) ;
}
